Class("Button") ({

	["load"] = function(s)
		table.insert(GUIs,s)
		s.size = {64,32}
	end,

	["text"] = "Button",
	["textRelativePosition"] = {0,0},
	["textColor"] = {0,0,0},
	
	["adjustSizeToText"] = function(s)
		--Automatically minimises size (Also adds padding.)
		local font = love.graphics.getFont()
		local txtWidth = font:getWidth(s.text)
		local txtHeight = font:getHeight(s.text)
		
		s.size = {txtWidth+5,txtHeight+5}
		s.textRelativePosition = {2.5, 2.5}
	end,
	
	["draw"] = function(s,Args)
		local size = s.size
		local position = s.position
		local scaleX, scaleY = size[1]/32, size[2]/32
		
		local pr,pg,pb,al = love.graphics.getColor()
		love.graphics.setColor(s.backgroundColor[1],s.backgroundColor[2],s.backgroundColor[3])
		love.graphics.draw(GUIGraphics["Backing"],position[1],position[2],0,size[1],size[2])	
		love.graphics.setColor(s.textColor[1],s.textColor[2],s.textColor[3])
		love.graphics.print(s.text,position[1]+s.textRelativePosition[1],position[2]+s.textRelativePosition[2],0,1,1)	
		love.graphics.setColor(pr,pg,pb,al)
	end,
	
	["update"] = function(s)
	end,
	
	["mousePressed"] = {
		["connect"] = function(s,connectFunc)
			table.insert(s.callBacks,connectFunc)
		end,
		["runEvents"] = function(s,x,y)
			for _,v in pairs(s.callBacks) do
				coroutine.resume(coroutine.create(function()
					v(x,y)
				end))
			end
		end,
		callBacks = {},
	},
	
	["mouseReleased"] = {
		["connect"] = function(s,connectFunc)
			table.insert(s.callBacks,connectFunc)
		end,
		["runEvents"] = function(s,x,y)
			for _,v in pairs(s.callBacks) do
				coroutine.resume(coroutine.create(function()
					v(x,y)
				end))
			end
		end,
		callBacks = {},
	},
	
	["mouseClicked"] = {
		["connect"] = function(s,connectFunc)
			table.insert(s.callBacks,connectFunc)
		end,
		["runEvents"] = function(s,x,y)
			for _,v in pairs(s.callBacks) do
				coroutine.resume(coroutine.create(function()
					v(x,y)
				end))
			end
		end,
		callBacks = {},
	},
	
	["mouseEntered"] = {
		["connect"] = function(s,connectFunc)
			table.insert(s.callBacks,connectFunc)
		end,
		["runEvents"] = function(s,x,y)
			for _,v in pairs(s.callBacks) do
				coroutine.resume(coroutine.create(function()
					v(x,y)
				end))
			end
		end,
		callBacks = {},
	},
	
	["mouseExited"] = {
		["connect"] = function(s,connectFunc)
			table.insert(s.callBacks,connectFunc)
		end,
		["runEvents"] = function(s,x,y)
			for _,v in pairs(s.callBacks) do
				coroutine.resume(coroutine.create(function()
					v(x,y)
				end))
			end
		end,
		callBacks = {},
	}
	
	}, {GUIElement})