require("GUIElements\/GUIClassDecleration.lua")

mouseDownCache = love.mouse.isDown("l")

GUIGraphics = 	{
			["Check"] = love.graphics.newImage("GUIUI\/Check.png"),
			["Backing"] = love.graphics.newImage("GUIUI\/Backing.png"),
			["Shading"] = love.graphics.newImage("GUIUI\/Shading.png"),
			["IntenseShading"] = love.graphics.newImage("GUIUI\/IntenseShading.png"),
				}
GUIs = {}

function GUIUpdate()
	for _,v in pairs(GUIs) do
		v:gUpdate()
		v:update()
	end
	mouseDownCache = love.mouse.isDown("l")
end

function GUIDraw()
	for _,v in pairs(GUIs) do
		v:draw()
		v:drawBorder()
		v:drawShading()
	end
	for _,v in pairs(GUIs) do
		v:drawCaption()
	end
end

function drawBorder(x, y, x2, y2, lineWidth, lineColor)
	local lw = love.graphics.getLineWidth()
	local pr, pg, pb, al = love.graphics.getColor()
	
	love.graphics.setLineWidth(lineWidth)
	love.graphics.setColor(lineColor[1],lineColor[2],lineColor[3])
	
	--Topleft-Topright
	love.graphics.line(x, y, x2, y)
	
	--Topleft-Bottomleft
	love.graphics.line(x, y, x, y2)
	
	--Topright-Bottomright
	love.graphics.line(x2, y, x2, y2)

	--Bottomleft-Bottomright
	love.graphics.line(x, y2, x2, y2)
	
	love.graphics.setColor(pr,pg,pb,al)
	love.graphics.setLineWidth(lw)
end

				
require("GUIElements\/CheckBox.lua")
require("GUIElements\/Button.lua")
require("GUIElements\/TextLabel.lua")