require("Class.lua")
require("GUIElements\/GUIMain.lua")
require("debug.lua")

function love.load()
	EventLog = ""
	love.graphics.setFont(12)
	textEraseTime = 0
	love.graphics.setBackgroundColor(255,255,255)
	CheckBox:new("Check1")
	Check1.size = {40,40}
	Check1.position = {10,10}
	Check1.borderWidth = 2
	Check1.backgroundColor = {0,255,255}
	Check1.borderColor = {255,0,0}
	Check1.hasCaption = true
	Check1.caption = "Checkbox caption. State: false"
	Check1.checkStateChanged:connect(function(state)
		textEraseTime = 1
		Check1.caption = "Checkbox caption. State: "..tostring(state)
		if state then
			EventLog = EventLog .. "Checkbox was checked.\n"
		else
			EventLog = EventLog .. "Checkbox was unchecked.\n"
		end
	end)
	
	Check1.mousePressed:connect(function(x,y)
		EventLog = EventLog .. "Mouse pressed down on checkbox at x:"..x.." y:"..y..".\n"
	end)
	Check1.mouseReleased:connect(function(x,y)
		EventLog = EventLog .. "Mouse released on checkbox at x:"..x.." y:"..y..".\n"
	end)
	Check1.mouseClicked:connect(function(x,y)
		EventLog = EventLog .. "Mouse clicked on checkbox at x:"..x.." y:"..y..".\n"
	end)
	Check1.mouseEntered:connect(function(x,y)
		EventLog = EventLog .. "Mouse entered checkbox at x:"..x.." y:"..y..".\n"
	end)
	Check1.mouseExited:connect(function(x,y)
		EventLog = EventLog .. "Mouse exited checkbox at x:"..x.." y:"..y..".\n"
	end)
	
	Button:new("Button1")
	Button1.position = {100,10}
	Button1.text = "Change checkbox state via button"
	Button1:adjustSizeToText()
	Button1.borderWidth = 2
	Button1.backgroundColor = {0,255,255}
	Button1.borderColor = {255,0,0}
	Button1.hasCaption = true
	Button1.caption = "Button caption. Mousedown: false"
	Button1.mousePressed:connect(function(x,y)
		Button1.caption = "Button caption. Mousedown: true"
		EventLog = EventLog .. "Mouse pressed on button at x:"..x.." y:"..y..".\n"
	end)
	Button1.mouseReleased:connect(function(x,y)
		Button1.caption = "Button caption. Mousedown: false"
		EventLog = EventLog .. "Mouse released on button at x:"..x.." y:"..y..".\n"
	end)
	Button1.mouseClicked:connect(function(x,y)
		Button1.caption = "Button caption. Registered a mouseClick!"
		EventLog = EventLog .. "Mouse clicked on button at x:"..x.." y:"..y..".\n"
		Check1:changeState()
	end)
	Button1.mouseEntered:connect(function(x,y)
		EventLog = EventLog .. "Mouse entered button at x:"..x.." y:"..y..".\n"
	end)
	Button1.mouseExited:connect(function(x,y)
		EventLog = EventLog .. "Mouse exited button at x:"..x.." y:"..y..".\n"
	end)
	
	Button:new("Button2")
	Button2.position = {100,60}
	Button2.text = "Change checkbox state via button"
	Button2:adjustSizeToText()
	Button2.borderWidth = 2
	Button2.backgroundColor = {0,255,255}
	Button2.borderColor = {255,0,0}
	Button2.hasCaption = true
	Button2.caption = "Button caption. Mousedown: false"
	Button2.mousePressed:connect(function(x,y)
		Button2.caption = "Button caption. Mousedown: true"
		EventLog = EventLog .. "Mouse pressed on button2 at x:"..x.." y:"..y..".\n"
	end)
	Button2.mouseReleased:connect(function(x,y)
		Button2.caption = "Button caption. Mousedown: false"
		EventLog = EventLog .. "Mouse released on button2 at x:"..x.." y:"..y..".\n"
	end)
	Button2.mouseClicked:connect(function(x,y)
		Button2.caption = "Button caption. Registered a mouseClick!"
		EventLog = EventLog .. "Mouse clicked on button2 at x:"..x.." y:"..y..".\n"
		Check1:changeState()
	end)
	Button2.mouseEntered:connect(function(x,y)
		EventLog = EventLog .. "Mouse entered button2 at x:"..x.." y:"..y..".\n"
	end)
	Button2.mouseExited:connect(function(x,y)
		EventLog = EventLog .. "Mouse exited button2 at x:"..x.." y:"..y..".\n"
	end)
	
	TextLabel:new("Label1")
	Label1.position = {100,Button1.position[2]+Button1.size[2]}
	Label1.text = "This is a text label. Visually it looks like a button but it doesn't interact."
	Label1:adjustSizeToText()
	Label1.hasBorder = false
	Label1.backgroundColor = {255,0,0}
	Label1.hasCaption = true
	Label1.caption = "Label caption. Labels have no events currently."
	Label1.mouseEntered:connect(function(x,y)
		EventLog = EventLog .. "Mouse entered label at x:"..x.." y:"..y..".\n"
	end)
	Label1.mouseExited:connect(function(x,y)
		EventLog = EventLog .. "Mouse exited label at x:"..x.." y:"..y..".\n"
	end)

end

function love.update(Time)
	GUIUpdate()
	if textEraseTime > 0 then
		textEraseTime = textEraseTime - Time
	end
end

function love.draw(Time)
	GUIDraw()
	love.graphics.setColor(0,0,0)
	love.graphics.print("EVENT LOG:\n"..EventLog, 10, 150,0)
end

